Name	= Frog
CC 		= gcc
CCFLAGS = -m68000 -Wall -nostartfiles -nodefaultlibs -fno-builtin -fomit-frame-pointer -ffast-math
AS 		= as
ASFLAGS = -m68000 --register-prefix-optional
LD 		= gcc
LDFLAGS = -Wl,-Map,$(Name).map
BIN		= objcopy
INCPATH	= \NeoDev\include
LIBS 	= -lmath -lc -lgcc
LIBPATH	= \NeoDev\lib
ROMSIZE = 0x80000
PADBYTE = 0x00
OUTPUT	= NeoGeoCart
BUILD	= Debug
FILES	= $(BUILD)\StartUp.o $(BUILD)\Main.o $(BUILD)\Game.o $(BUILD)\Routines.o $(BUILD)\Sound.o $(BUILD)\Sprites.o
DATA	= Data\Screen1Pal.o Data\TitlePal.o Data\BackPal.o Data\FontPal.o Data\SpritePal.o Data\Sprite2Pal.o Data\Screen1Map.o Data\TitleMap.o Data\BackMap.o
PATH	= C:\NeoDev\bin;C:\Dos;%PATH%

all : $(Name).bin

$(Name).bin: $(BUILD)\$(Name).obj
	$(BIN) --gap-fill=$(PADBYTE) --pad-to=$(ROMSIZE) -R .data -O binary $(BUILD)\$(Name).obj $(Name).bin
	flip $(Name).bin 014-p1.bin
	copy 014*.bin c:\mame\roms\mutnat

$(BUILD)\$(Name).obj: $(FILES)
	$(LD) -L$(LIBPATH) $(CCFLAGS) $(LDFLAGS) -T C:\NeoDev\lib\ldscripts\$(OUTPUT).x -o $(BUILD)\$(Name).obj $(FILES) $(DATA) $(LIBS)

$(BUILD)\Main.o : Main.c
	$(CC) -O1 -I$(INCPATH) $(CCFLAGS) -c Main.c -o $(BUILD)\Main.o 2>&1 | Gcc2MS

$(BUILD)\Game.o : Game.c
	$(CC) -O0 -I$(INCPATH) $(CCFLAGS) -c Game.c -o $(BUILD)\Game.o 2>&1 | Gcc2MS

$(BUILD)\Routines.o : Routines.s
	$(AS) $(ASFLAGS) -o $(BUILD)\Routines.o Routines.s

$(BUILD)\Sound.o : Sound.c
	$(CC) -O0 -I$(INCPATH) $(CCFLAGS) -c Sound.c -o $(BUILD)\Sound.o 2>&1 | Gcc2MS

$(BUILD)\Sprites.o : Sprites.c
	$(CC) -O0 -I$(INCPATH) $(CCFLAGS) -c Sprites.c -o $(BUILD)\Sprites.o 2>&1 | Gcc2MS

$(BUILD)\StartUp.o : StartUp.s
	$(AS) $(ASFLAGS) -o $(BUILD)\StartUp.o StartUp.s 2>&1 | Gcc2MS

CLEAN :
	-@erase $(BUILD)\StartUp.o
	-@erase $(BUILD)\Main.o
	-@erase $(BUILD)\Routines.o
	-@erase $(BUILD)\Sprites.o
	-@erase $(BUILD)\Frog.obj
	-@erase $(Name).bin

