Name	= Frog
CC 		= gcc
CCFLAGS = -m68000 -Wall -nostartfiles -nodefaultlibs -fno-builtin -fomit-frame-pointer -ffast-math
AS 		= as
ASFLAGS = -m68000 --register-prefix-optional
LD 		= gcc
LDFLAGS = -Wl,-Map,$(Name).map
BIN		= objcopy
INCPATH	=
LIBS 	= -lmath -lc -lgcc
LIBPATH	= C:\NeoDev\m68k\lib
ROMSIZE = 0x80000
PADBYTE = 0x00
OUTPUT	= NeoGeoCart
BUILD	= Release
FILES	= $(BUILD)\StartUp.o $(BUILD)\Main.o $(BUILD)\Game.o $(BUILD)\Routines.o $(BUILD)\Sprites.o
DATA	= Data\TitlePal.o Data\BackPal.o Data\FontPal.o Data\SpritePal.o Data\TitleMap.o Data\BackMap.o

all : $(Name).bin

$(Name).bin: $(BUILD)\$(Name).obj
	$(BIN) --gap-fill=$(PADBYTE) --pad-to=$(ROMSIZE) -R .data -O binary $(BUILD)\$(Name).obj $(Name).bin
	flip $(Name).bin 202-p1.bin
	copy 202*.bin c:\mame\roms\puzzledp

$(BUILD)\$(Name).obj: $(FILES)
	$(LD) -L$(LIBPATH) $(CCFLAGS) $(LDFLAGS) -T C:\NeoDev\m68k\lib\ldscripts\$(OUTPUT).x -o $(BUILD)\$(Name).obj $(FILES) $(DATA) $(LIBS)

$(BUILD)\Main.o : Main.c
	$(CC) -O4 -I$(INCPATH) $(CCFLAGS) -c Main.c -o $(BUILD)\Main.o

$(BUILD)\Game.o : Game.c
	$(CC) -O0 -I$(INCPATH) $(CCFLAGS) -c Game.c -o $(BUILD)\Game.o

$(BUILD)\Routines.o : Routines.s
	$(AS) $(ASFLAGS) -o $(BUILD)\Routines.o Routines.s

$(BUILD)\Sprites.o : Sprites.c
	$(CC) -O0 -I$(INCPATH) $(CCFLAGS) -c Sprites.c -o $(BUILD)\Sprites.o

$(BUILD)\StartUp.o : StartUp.s
	$(AS) $(ASFLAGS) -o $(BUILD)\StartUp.o StartUp.s

CLEAN :
	-@erase $(BUILD)\StartUp.o
	-@erase $(BUILD)\Main.o
	-@erase $(BUILD)\Routines.o
	-@erase $(BUILD)\Sprites.o
	-@erase $(BUILD)\Frog.obj
	-@erase Frog.bin

