********************** Exported Symbols **********************
	.globl	_start
	.globl	atexit

********************** Imported Symbols **********************
	.globl	__do_global_ctors
	.globl	__do_global_dtors
	.globl	main
	.globl	memset
	.globl	__bss_start
	.globl	_end

	.include "Includes/Defines.inc"

	.extern	VBlank
	.extern	Seed

	* Stack Ptr = 0x10F300
	* InitialPC = 0xC00402
	dc.l	0x10F300,	0xC00402,	0xC00408,	0xC0040E	
													
	* Ptr to debugging switch = 0x00C00414
	dc.l	0xC00414,	0xC00426,	0xC00426,	0xC00426
	dc.l	0xC0041A,	0xC00420,	0xC00426,	0xC00426
	dc.l	0xC00426,	0xC00426,	0xC00426,	0xC0042C
	dc.l	0xC00522,	0xC00528,	0xC0052E,	0xC00534
	dc.l	0xC0053A,	0xC004F2,	0xC004EC,	0xC004E6

	* Interrupt pointers
	dc.l	0xC004E0,	VBlank,		Irq2,		Irq3
    
	dc.l	Dummy,		Dummy,		Dummy,		Dummy
	
	* Traps
	dc.l	Dummy,		Dummy,		Dummy,		Dummy
	dc.l	Dummy,		Dummy,		Dummy,		Dummy
	dc.l	Dummy,		Dummy,		Dummy,		Dummy
	dc.l	Dummy,		Dummy,		Dummy,		Dummy
	
	dc.l	0xC00426,	0xC00426,	0xC00426,	0xC00426
	dc.l	0xC00426,	0xC00426,	0xC00426,	0xC00426
	dc.l	0xC00426,	0xC00426,	0xC00426,	0xC00426
	dc.l	0xC00426,	0xC00426,	0xC00426,	0xC00426

	* Magic bytes
	.ascii	"NEO-GEO"
	
	* CDDA Flag
	dc.b	0x00

	* 0x0273 = NGH number
	dc.w	0x0273									
	
	* Unknown
	dc.l	0x00000000							    
	
	* Pointer to debugging switch
	dc.l	0x10E000								
	
	* Starting sprite number = 0x0000
	dc.w	0x0000									
	
	* Logo start
	dc.w	0x0016

	* Pointer to Japanese config
	dc.l	JapaneseConfig							
	
	* Pointer to English config
	dc.l	EnglishConfig							
	
	* Pointer to Spanish config
	dc.l	SpanishConfig							

	* Entry point of program
	jmp		_start									
	jmp		Start2
	jmp		Start3
	jmp		Start4

	dc.l	0xFFFFFFFF,	0xFFFFFFFF,	0xFFFFFFFF,	0xFFFFFFFF
	dc.l	0xFFFFFFFF,	0xFFFFFFFF,	0xFFFFFFFF,	0xFFFFFFFF
	dc.l	0xFFFFFFFF,	0xFFFFFFFF,	0xFFFFFFFF,	0xFFFFFFFF
	dc.l	0xFFFFFFFF,	0xFFFFFFFF,	0xFFFFFFFF,	0xFFFFFFFF
	dc.l	0xFFFFFFFF,	0xFFFFFFFF

	* Pointer to security code
	dc.l	Security								

	* Securty code
Security:
	moveq	#0, d3
	
	tst.w	0xa14(a5)
	bne		l2a53a
	
	movea.l	0xa04(a5), a0
	move.w	0xa08(a5), d7

l2a508:
	move.b	d0, 0x300001
	move.w	(a0), d1

	cmpi.b	#0xff, d1
	beq.s	l2a530

	move.w	2(a0), d0
	
	cmp.b	0xace(a5), d0
	bne.s	l2a530
	
	move.w	4(a0), d0
	
	cmp.b	0xacf(a5), d0
	bne.s	l2a530
	
	cmp.b	0xad0(a5), d1
	beq.s	l2a538

l2a530:
	addq.l	#8,a0
	dbf		d7, l2a508
	
	move.w	d7, d3

l2a538:
	rts

l2a53a:
	movea.l	0xa04(a5), a0
	move.w	0xa08(a5), d7

l2a542:
	move.w	(a0), d1
	lsr.w	#8, d1
	
	cmpi.b	#0xff, d1
	beq.s	l2a566
	
	move.w	(a0), d0
	
	cmp.b	0xace(a5), d0
	bne.s	l2a566
	
	move.w	2(a0), d0
	lsr.w	#8, d0
	
	cmp.b	0xacf(a5), d0
	bne.s	l2a566
	
	cmp.b	0xad0(a5), d1
	beq.s	l2a56e

l2a566:
	addq.l	#4, a0
	dbf		d7, l2a542
	move.w	d7, d3

l2a56e:
	rts

	.align	4

JapaneseConfig:
	.ascii	"FROG FEAST JP   "
	dc.l	0xFFFFFFFF
	dc.w	0x0364
	dc.b	0x14, 0x13, 0x24, 0x01

EnglishConfig:
	.ascii	"FROG FEAST EN   "
	dc.l	0xFFFFFFFF
	dc.w	0x0364
	dc.b	0x14, 0x13, 0x24, 0x01

SpanishConfig:
	.ascii	"FROG FEAST SP   "
	dc.l	0xFFFFFFFF
	dc.w	0x0364
	dc.b	0x14, 0x13, 0x24, 0x01

* Irq2 interrupt routine
Irq2:
	* IRQ 2 acknowledge
	move.w	#2, 0x3C000C			
	rte

	.align	4

* Irq3 interrupt routine
Irq3:
	* IRQ 3 acknowledge
	move.w	#1, 0x3C000C			
	rte

	.align	4

* Dummy interrupt routine
Dummy:
	rte

	.align	4

* Dummy atexit (does nothing for now)
atexit:
	moveq	#0, d0
	rts

	.align	4

_start:
	* Set stack pointer
	lea		0x10F300,sp

	* Reset watchdog
	move.b	d0, 0x300001			

	* ???
	move.w	#0, 0x3C0006			
	
	* Acknowledge all interrupts
	move.b	#7, 0x3C000C
	
	* Call bios routine
	jsr		0xC004C2

	* Call bios routine
	jsr		0xC004C8

	* Call bios routine
	jsr		0xC0044A

	* Enable interrupts
	move.w	#0x2000, sr

	* Initialize base pointers for malloc
	move.l	#0x100030, _sbrk_base2
	move.l	#_end, d0
	add.l	#32, d0
	and.l	#0xFFFFFF0, d0
	move.l	d0, _sbrk_base1

	* Initialize BSS section
	move.l	#_end, d0
	sub.l	#__bss_start, d0
	move.l	d0, -(a7)
	clr.l	-(a7)
	pea		__bss_start
	jbsr	memset	

	* Seed random number generator
	move.l	HBLANK_POS, d0
	jsr		Seed

	* Jump to main
	jbsr	main

	* Call global destructors
	jbsr	__do_global_dtors

EndLoop:
	bra.s	EndLoop

	.align	4

Start2:
	rts

Start3:
	rts

Start4:
	rts

	.align	4
